<template>
  <div>
    <base-dialog v-if="inputIsInvalid" title="InvalidInput">
      <template #default>
        <p>Unfortunetly, one of your input is invalid.</p>
        <p>Please check all fields.</p>
      </template>
      <template #actions>
        <button @click="confirmError">Okay</button>
      </template>
    </base-dialog>
    <base-card>
      <form @submit.prevent="submitData">
        <div class="form-control">
          <label for="title">Title <span>(required)</span></label>
          <input
            id="title"
            name="title"
            type="text"
            ref="titleInput"
            default="title"
          />
        </div>
        <div class="form-control">
          <label for="description">Description <span>(required)</span></label>
          <textarea
            id="description"
            name="description"
            rows="3"
            ref="descInput"
            default="title"
          ></textarea>
        </div>
        <div class="form-control">
          <label for="link">Link <span>(optional)</span></label>
          <p>Copy whole adress from your browser</p>
          <input id="link" name="link" type="url" ref="linkInput" />
        </div>
        <div>
          <button type="submit">Add Resource</button>
        </div>
      </form>
    </base-card>
  </div>
</template>

<script>
// import BaseDialog from "../UI/BaseDialog.vue";
export default {
  // components: { BaseDialog },
  inject: ["addResource"],
  data() {
    return {
      inputIsInvalid: false,
    };
  },
  methods: {
    submitData() {
      console.log("refs: ", this.$refs);
      const enteredTitle = this.$refs.titleInput.value;
      const enteredDescription = this.$refs.descInput.value;
      const enteredUrl = this.$refs.linkInput.value;
      if (enteredTitle.trim() === "" || enteredDescription.trim() === "") {
        this.inputIsInvalid = true;
        return;
      } else {
        this.addResource(enteredTitle, enteredDescription, enteredUrl);
        this.clearForm();
      }
    },
    confirmError() {
      this.inputIsInvalid = false;
    },
    clearForm() {
      this.$refs.titleInput.value = "";
      this.$refs.descInput.value = "";
      this.$refs.linkInput.value = "";
    },
  },
};
</script>

<style scoped>
label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}
label span {
  font-weight: normal;
  font-size: 0.7rem;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  padding: 0.15rem;
  border: 1px solid #ccc;
}

input:focus,
textarea:focus {
  outline: none;
  border-color: #3a0061;
  background-color: #f7ebff;
}
input,
textarea {
  display: block;
  width: 100%;
  max-width: 100%;
  min-width: 100%;
  font: inherit;
  padding: 0.15rem;
  border: 1px solid #ccc;
}

.form-control {
  margin: 1rem 0;
}
.form-control p {
  font-size: 0.8rem;
}
button {
  padding: 0.75rem 1.5rem;
  font-family: inherit;
  background-color: #3a0061;
  border: 1px solid #3a0061;
  color: white;
  cursor: pointer;
}
</style>
